
	.586
	.model flat,stdcall
	option casemap:none
	
	include windows.inc
	include kernel32.inc
	include user32.inc
	include gdi32.inc
	includelib kernel32.lib
	includelib user32.lib
	includelib gdi32.lib
	
	include Morse_Transmitter.inc
	
	WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
	DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
	
	.const
	IDD_DLG equ 1001
	IDC_SEND equ 1005
	IDC_EDIT equ 1004
	IDM_OPEN equ 502
	IDM_SAVE equ 503
	IDM_SAVEAS equ 504

	
	.data
	
	hInstance HINSTANCE 0
	hDlg dd 0
	libName db "Morse_Transmitter.dll",0
	hModule dd 0
	hMorse dd 0
	Fmt db "%lu",0
	hMenu dd 0
	FileName dd 0
	
	.code
	start:
			
		invoke GetModuleHandle,NULL
		mov hInstance,eax
		invoke LoadLibrary,addr libName
		mov hModule,eax
		invoke WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
		invoke ExitProcess,0
		
WinMain PROC hInst:DWORD,hPrevInst:DWORD,lpCmdLine:DWORD,nCmdShow:DWORD
	
		LOCAL msg :MSG
			
			invoke CreateDialogParam,hInst,IDD_DLG,NULL,addr DlgProc,0
			mov hDlg,eax
			.repeat
			invoke GetMessage,addr msg,hDlg,0,0
			.break .if(!eax)
			invoke TranslateMessage,addr msg
			invoke DispatchMessage,addr msg
			.until FALSE	
			
		mov eax,msg.wParam
	ret
WinMain ENDP

DlgProc PROC hwnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	
	LOCAL rc:RECT
	LOCAL hEdit :HWND
	LOCAL strBuffer[128]:BYTE

		.if uMsg == WM_CLOSE
				
			invoke FreeLibrary,hModule
			invoke ExitProcess,0
			
		.elseif uMsg == WM_SIZE
				
			invoke GetClientRect,hwnd,addr rc
			invoke GetDlgItem,hwnd,1004
			mov hEdit,eax
			mov eax,rc.top
			add eax,90
			mov rc.top,eax
			mov eax,rc.bottom
			sub eax,103
			mov rc.bottom,eax
			mov eax,rc.left
			add eax,2
			mov ebx,rc.right
			sub ebx,4
			invoke MoveWindow,hEdit,eax,rc.top,ebx,rc.bottom,TRUE
			
		.elseif uMsg == WM_SETFOCUS
				
			invoke SetFocus,hwnd
			
			
		.elseif uMsg == WM_INITDIALOG
				
			invoke LoadIcon,hInstance,400
			invoke SendMessage,hwnd,WM_SETICON,ICON_BIG,eax
			invoke LoadMenu,hInstance,500
			mov hMenu,eax
			invoke SetMenu,hwnd,eax
			invoke GetDlgItem,hwnd,1002
			mov hMorse,eax
			invoke SendMessage,hMorse,MC_GETTONE,0,0
			invoke wsprintf,addr strBuffer,addr Fmt,eax
			invoke SetDlgItemText,hwnd,1011,addr strBuffer
			;----getting the speed
			invoke SendMessage,hMorse,MC_GETSPEED,TRUE,0
			invoke wsprintf,addr strBuffer,addr Fmt,eax
			invoke SetDlgItemText,hwnd,1016,addr strBuffer
			invoke SendMessage,hMorse,MC_GETSPEED,0,TRUE 
			invoke wsprintf,addr strBuffer,addr Fmt,eax
			invoke SetDlgItemText,hwnd,1008,addr strBuffer		
		
		.elseif uMsg == WM_COMMAND
				
			.if wParam == 1010
					
					
				invoke SendMessage,hMorse,MC_DECREASE,1,0
				invoke SendMessage,hMorse,MC_GETSPEED,TRUE,0
				invoke wsprintf,addr strBuffer,addr Fmt,eax
				invoke SetDlgItemText,hwnd,1016,addr strBuffer
				invoke SendMessage,hMorse,MC_GETSPEED,0,TRUE
				invoke wsprintf,addr strBuffer,addr Fmt,eax
				invoke SetDlgItemText,hwnd,1008,addr strBuffer
				
			.elseif wParam == 1009
					
				invoke SendMessage,hMorse,MC_INCREASE,1,0
				invoke SendMessage,hMorse,MC_GETSPEED,TRUE,0
				invoke wsprintf,addr strBuffer,addr Fmt,eax
				invoke SetDlgItemText,hwnd,1016,addr strBuffer
				invoke SendMessage,hMorse,MC_GETSPEED,0,TRUE
				invoke wsprintf,addr strBuffer,addr Fmt,eax
				invoke SetDlgItemText,hwnd,1008,addr strBuffer
				
			.endif
			
			.if wParam == 1012
					
				invoke SendMessage,hMorse,MC_TONEUP,10,0
				invoke SendMessage,hMorse,MC_GETTONE,0,0
				invoke wsprintf,addr strBuffer,addr Fmt,eax
				invoke SetDlgItemText,hwnd,1011,addr strBuffer
				
			.elseif wParam == 1013
					
				invoke SendMessage,hMorse,MC_TONEDOWN,10,0
				invoke SendMessage,hMorse,MC_GETTONE,0,0
				invoke wsprintf,addr strBuffer,addr Fmt,eax
				invoke SetDlgItemText,hwnd,1011,addr strBuffer
				invoke GetDlgItem,hwnd,1011
				
			.elseif wParam == IDC_SEND
					
				invoke GetDlgItem,hwnd,IDC_EDIT
				mov hEdit,eax
				invoke SendMessage,hMorse,MC_AUTOTRANSMITTER,hEdit,NULL
				
			.elseif wParam == IDM_OPEN
					
				invoke GetDlgItem,hwnd,IDC_EDIT
				mov hEdit,eax
				invoke SendMessage,hMorse,MC_OPEN,hwnd,hEdit
				mov FileName,eax
				
			.elseif wParam == IDM_SAVEAS
					
				invoke GetDlgItem,hwnd,IDC_EDIT
				mov hEdit,eax
				invoke SendMessage,hMorse,MC_SAVEAS,hwnd,hEdit
				
				
			.elseif wParam == IDM_SAVE
					
				invoke GetDlgItem,hwnd,IDC_EDIT
				mov hEdit,eax
				invoke SendMessage,hMorse,MC_SAVE,FileName,hEdit
				
				
			.endif
			
		.endif		
	xor eax,eax
	ret
DlgProc ENDP

END start