
.data

	filter db "RGR files (*.rgr)",0,"*.rgr",0,"All files (*.*)",0,"*.*",0,0
	defext db "rgr",0
	
	szFileName dd 0
.data?

		hFileName DWORD ?
		path DWORD ?
		
	
.code
fmanip PROC hParent:DWORD,hEdit:HWND,flags:DWORD
			
		LOCAL ofn :OPENFILENAME
		
			invoke SendMessage,hEdit,EM_SETLIMITTEXT,0,0
			invoke  RtlZeroMemory,addr ofn,sizeof ofn
			
			.if flags == 1
					
				mov szFileName,NULL
				
			.endif
			
			mov ofn.lStructSize,sizeof ofn
			push hParent
			pop ofn.hwndOwner
			mov ofn.lpstrFilter,offset filter
			push offset szFileName
			pop ofn.lpstrFile
			mov ofn.nMaxFile,MAX_PATH
			mov ofn.lpstrDefExt,offset defext
			mov ofn.Flags,OFN_EXPLORER or OFN_FILEMUSTEXIST
			invoke GetModuleHandle,NULL
			mov ofn.hInstance,eax
			
			.if flags == 1	;open
					
				invoke GetOpenFileName,addr ofn
				invoke LoadFile,hEdit,addr szFileName	
				mov eax,szFileName
				ret
				
			.elseif flags == 3 ;saveas
					
				mov szFileName,NULL
				push offset filter 
				pop ofn.lpstrFilter
				invoke GetSaveFileName,addr ofn
				invoke SaveFile,hEdit,ofn.lpstrFile

			.elseif flags == 2 ;save
					
				push offset szFileName
				pop ofn.lpstrFile
				invoke SaveFile,hEdit,ofn.lpstrFile
				
			.endif
	
	mov eax,szFileName
	ret
fmanip ENDP


LoadFile PROC  hEditBOX:DWORD,pszFileName:DWORD
			
		LOCAL hFile 	    :DWORD
		LOCAL dwFileSize    :DWORD
		LOCAL pszFileText   :DWORD
		LOCAL dwRead	    :DWORD
		
			invoke CreateFile,pszFileName,GENERIC_READ,
								FILE_SHARE_READ,
								NULL,OPEN_EXISTING,
								FILE_ATTRIBUTE_NORMAL or \
								FILE_ATTRIBUTE_READONLY,NULL
			mov hFile,eax
				
			.if eax != INVALID_HANDLE_VALUE
					
				invoke GetFileSize,hFile,NULL
				mov dwFileSize,eax
				
				.if eax != NULL
						
					invoke SysAllocStringByteLen,0,dwFileSize
					mov pszFileText,eax
					invoke ReadFile,hFile,pszFileText,dwFileSize,ADDR dwRead,NULL
					push pszFileText
					invoke SetWindowText,hEditBOX,pszFileText
					pop pszFileText
					invoke SysFreeString,pszFileText
					invoke CloseHandle,hFile
					mov eax,pszFileName
					ret
						
				.endif
				
			invoke CloseHandle,hFile
				
			.else
					
				mov eax,FALSE	
				ret
					
			.endif
		
	ret
LoadFile ENDP
SaveFile PROC  hEditBOX:DWORD,pszFileName:DWORD
		
		LOCAL hFile 	   :DWORD
		LOCAL dwFileSize  :DWORD
		LOCAL pszFileText :DWORD
		LOCAL dwWrite	   :DWORD
			
			invoke CreateFile,pszFileName,GENERIC_WRITE,
							0,0,CREATE_ALWAYS,
							FILE_ATTRIBUTE_NORMAL,0
			mov hFile,eax	
				
			.if eax != INVALID_HANDLE_VALUE
					
				invoke GetWindowTextLength,hEditBOX	
				mov dwFileSize,eax
					
				.if eax != NULL
						
					invoke SysAllocStringByteLen,0,dwFileSize
					mov pszFileText,eax
					invoke GetWindowText,hEditBOX,pszFileText,dwFileSize-1
					invoke WriteFile,hFile,pszFileText,dwFileSize,ADDR dwWrite,NULL
					
				.endif
				
				invoke SysFreeString,pszFileText
				invoke CloseHandle,hFile
				mov eax,TRUE
				ret
				
			.endif	
				 
			invoke CloseHandle,hFile
		ret 
		
SaveFile ENDP
